#
# See the file "LICENSE" for the full license governing this code.
#
#
# Get a list of all Oracle uses that use the default profile
#
require_relative '../puppet_x/enterprisemodules/ora_cis/facts'

ora_cis_fact('access_to_aud')                   { "select distinct grantee as name from dba_tab_privs where table_name='AUD$'" }
ora_cis_fact('access_to_link')                  { "select distinct grantee as name from dba_tab_privs where table_name='LINK$'" }
ora_cis_fact('access_to_scheduler_credentials') { "select distinct grantee as name from dba_tab_privs where table_name='SCHEDULER$_CREDENTIAL'" }
ora_cis_fact('access_to_user_history')          { "select distinct grantee as name from dba_tab_privs where table_name='USER_HISTORY$'" }
ora_cis_fact('access_to_user_mig')              { "select distinct grantee as name from dba_tab_privs where table_name='USER$MIG'" }
ora_cis_fact('access_to_user')                  { "select distinct grantee as name from dba_tab_privs where table_name='USER$'" }
ora_cis_fact('accounts_with_default_passwords') { 'select distinct username as name from dba_users_with_defpwd' }
ora_cis_fact('any_privileges')                  { "select distinct privilege as name from dba_sys_privs where privilege like '%ANY%'" }
ora_cis_fact('accounts_with_admin_grants')      { "select distinct grantee as name from dba_sys_privs where admin_option='YES'" }
ora_cis_fact('apex_users')                      { "select username as name from dba_users where REGEXP_LIKE(username,'^APEX_0[3-9][0-9][0-9][0-9][0-9]$')" }
ora_cis_fact('access_to_dba_tables')            { "select distinct grantee as name  from dba_tab_privs where table_name like 'DBA_%'"}
ora_cis_fact('profiles')                        { 'select distinct profile as name from dba_profiles' }
ora_cis_fact('proxy_users')                     { 'select proxy as name from dba_proxies' }
ora_cis_fact('roles')                           { 'select role as name from dba_roles' }
ora_cis_fact('users')                           { 'select username as name from dba_users' }
ora_cis_fact('users_roles')                     { 'select username as name from dba_users union select role as name from dba_roles' }
ora_cis_fact('users_with_default_profile')      { "select distinct username as name from dba_users where profile='DEFAULT' and account_status='OPEN'" }
ora_cis_fact('users_with_external_password')    { "select distinct username as name from dba_users where password='EXTERNAL'" }
ora_cis_fact('maintained_users')                { "select distinct username as name from cdb_users where oracle_maintained='Y'" }
ora_cis_fact('maintained_roles')                { "select distinct role as name from cdb_roles where oracle_maintained='Y'" }
ora_cis_fact('maintained_users_roles')          { "select distinct username as name from cdb_users where oracle_maintained='Y' union select distinct role as name from cdb_roles where oracle_maintained='Y'" }
ora_cis_fact('non_maintained_users')            { "select distinct username as name from cdb_users where oracle_maintained='N'" }
ora_cis_fact('non_maintained_roles')            { "select distinct role as name from cdb_roles where oracle_maintained='N'" }
ora_cis_fact('non_maintained_users_roles')      { "select distinct username as name from cdb_users where oracle_maintained='N' union select distinct role as name from cdb_roles where oracle_maintained='N'" }
ora_cis_fact('non_maintained_users_roles')      { "select distinct username as name from cdb_users where oracle_maintained='N' union select distinct role as name from cdb_roles where oracle_maintained='N'" }
ora_cis_fact('global_profiles')                 { "select distinct profile as name from dba_profiles where profile like 'C##%'" }
ora_cis_fact('cis_audit_policy_exists')         { "select count(1) as name from AUDIT_UNIFIED_POLICIES AUD WHERE POLICY_NAME = 'CIS_UNIFIED_AUDIT_POLICY'" }
