#
# See the file "LICENSE" for the full license governing this code.
#
#
# Set the init.ora param to the specfied value
#
# $title      init,.ora parameter including the sid e.g. AUDIT_SYS_OPERATIONS@SID
# $value      Value to set the paremeter ro
# $ensure     Absent or present. Default 'present'
#
define ora_cis::internal::parameter(
  Any                       $value,
  Enum['present', 'absent'] $ensure = 'present'
){
  $full_name = "SPFILE/${title}"

  ora_init_param {$full_name:
    ensure => $ensure,
    value  => $value
  }
}
