#
# See the file "LICENSE" for the full license governing this code.
#
#
# Revoke public grants to the specfied resources
#
# $title      the grant including the sid e.g. DBMS_JAVA@SID
# $exclude    The users to exclude, e.g. not revoke
#
define ora_cis::internal::revoke_user_rights(
  Array  $exclude,
){
  $split = $title.split('@')
  $grant = $split[0]
  $sid   = $split[1]
  #
  # Check all accounts and remove the specfied grant
  #
  $users_to_check = ora_config::on_sid($::ora_users, $sid) - $exclude

  $users_to_check.each |$user| {
    $unique = ora_cis::random_id(6)
    $full_name = "Ora_user[${user}@${sid}]revoked/${unique}"

    resource_value { $full_name:
      add_value      => $grant,
      allow_create   => true,
      allow_redefine => true,
    }
  }
}
